// Class to create a tcp connection to send and recieve data
// Created by Jon So
// email : jon@unix-security.co.uk
// Written on 01.07.02

// include header files
#include <stdio.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <string.h>
#include <unistd.h>
#include <netdb.h>
#include <netinet/in.h>
#include <arpa/inet.h>

// define namespace
namespace tcpConSock
{
	// define tcpConSock class
	class tcpConSock
	{
		// define public methods
		public:
			tcpConSock();
			~tcpConSock();
			void setHost(char *rhost);
			void setPort(int port);
			int con();
			void discon();
			void sendData(char *sendbuff, int sendsize);
			void readData(char *readbuff, int readsize);
	
		// define private variables
		private:
			char *remotehost;
			int remoteport;
			int mysocket;
	};
	
	// constructor
	tcpConSock::tcpConSock()
	{
	}
	
	// deconstructor
	tcpConSock::~tcpConSock()
	{
	}
	
	// set host
	void tcpConSock::setHost(char *host)
	{
		remotehost = host;
	}
	
	// set port
	void tcpConSock::setPort(int port)
	{
		remoteport = port;
	}
	
	// connect
	int tcpConSock::con()
	{
		struct sockaddr_in server;
	
		bzero(&server, sizeof(server));
		server.sin_family = AF_INET;
		server.sin_port = htons(remoteport);
		if((mysocket = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
			return -1;
		}
		if (inet_pton((int) AF_INET, (const char *) remotehost, &server.sin_addr) <= 0 ) {
			return -1;
		}
		if ((connect(mysocket, (struct sockaddr *) &server, sizeof(server)) < 0)) {
			return -1;
		}
		return 0;
	}
	
	// disconnect
	void tcpConSock::discon()
	{
		close((int) mysocket);
	}
	
	// send
	void tcpConSock::sendData(char *sendbuff, int sendsize)
	{
		write((int) mysocket, (char *) sendbuff, (int) sendsize);
	}
	
	// read
	void tcpConSock::readData(char *readbuff, int readsize)
	{
		bzero(readbuff, readsize);
		read((int) mysocket, (char *) readbuff, (int) readsize);
	}

}
